---
title: Demo
metaTitle: Demo - Guide - Handsontable Documentation
permalink: /demo
canonicalUrl: /demo
tags:
  - demo
  - hello world
---

# Demo

[[toc]]

Play around with a demo of Handsontable, in your favorite framework.

<div class="example-container"><iframe
    src="https://handsontable.github.io/handsontable/examples/next/docs/js/demo/"
    allow="accelerometer; ambient-light-sensor; camera; encrypted-media; geolocation; gyroscope; hid; microphone;
      midi; payment; usb; vr; xr-spatial-tracking"
    sandbox="allow-forms allow-modals allow-popups allow-presentation allow-same-origin allow-scripts"
  ></iframe></div>

## Find the code on GitHub

- [JavaScript demo app](https://github.com/handsontable/handsontable/tree/develop/examples/next/docs/js/demo/)
- [TypeScript demo app](https://github.com/handsontable/handsontable/tree/develop/examples/next/docs/ts/demo/)
- [Angular demo app](https://github.com/handsontable/handsontable/tree/develop/examples/next/docs/angular/demo/)
- [React demo app](https://github.com/handsontable/handsontable/tree/develop/examples/next/docs/react/demo/)
- [Vue demo app](https://github.com/handsontable/handsontable/tree/develop/examples/next/docs/vue/demo/)

## Try out the demo's features

Explore the demo and discover Handsontable's most popular features:

- [Context menu](@/guides/accessories-and-menus/context-menu.md)
- [Dropdown cell type](@/guides/cell-types/dropdown-cell-type.md)
- [Column groups](@/guides/columns/column-groups.md)
- [Column menu](@/guides/columns/column-menu.md)
- [Column filter](@/guides/columns/column-filter.md)-
- [Column hiding](@/guides/columns/column-hiding.md)
- [Row sorting](@/guides/rows/row-sorting.md)
- And more!

## Edit the demo's source code

You can:
- View the complete source code behind your framework's demo
- Run your framework's demo on your local machine
- Fork the directory with your framework's demo, and add changes of your own

Just select your framework from the demo above.
